package client;

import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.*;
import io.netty.util.ReferenceCountUtil;

public class ClientHandler extends ChannelInboundHandlerAdapter {
    private static final byte[] MESSAGE = {(byte) 0x96, (byte) 0x52, (byte) 0x54, (byte) 0x56, (byte) 0x42, (byte) 0x1, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0xd1, (byte) 0x2f, (byte) 0x1, (byte) 0x0, (byte) 0x1, (byte) 0x18, (byte) 0x33, (byte) 0x63, (byte) 0x4a, (byte) 0xf0, (byte) 0x8e, (byte) 0x10, (byte) 0x3, (byte) 0x0, (byte) 0xc2, (byte) 0x98, (byte) 0x50, (byte) 0x28, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x2, (byte) 0xec, (byte) 0xd3, (byte) 0x8a, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x9c, (byte) 0x2d, (byte) 0x47, (byte) 0x3f, (byte) 0xd0, (byte) 0x86, (byte) 0x3f, (byte) 0x78, (byte) 0xba, (byte) 0x97, (byte) 0x41, (byte) 0xe9, (byte) 0x8e, (byte) 0x86, (byte) 0x3f, (byte) 0x0, (byte) 0x0, (byte) 0x80, (byte) 0x3f, (byte) 0xa, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x1a, (byte) 0x4, (byte) 0x2, (byte) 0x49, (byte) 0x13, (byte) 0x2, (byte) 0x28, (byte) 0xd4, (byte) 0x8a, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x9c, (byte) 0x2d, (byte) 0x47, (byte) 0x3f, (byte) 0xd0, (byte) 0x86, (byte) 0x3f, (byte) 0x19, (byte) 0x3d, (byte) 0x95, (byte) 0x41, (byte) 0xe9, (byte) 0x8e, (byte) 0x86, (byte) 0x3f, (byte) 0x0, (byte) 0x0, (byte) 0x80, (byte) 0x3f, (byte) 0xa, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x1b, (byte) 0x4, (byte) 0x2, (byte) 0x2f, (byte) 0x1e, (byte) 0x2, (byte) 0x64, (byte) 0xd4, (byte) 0x8a, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x9c, (byte) 0x2d, (byte) 0x47, (byte) 0x3f, (byte) 0xd0, (byte) 0x86, (byte) 0x3f, (byte) 0x37, (byte) 0xc9, (byte) 0x94, (byte) 0x41, (byte) 0xe9, (byte) 0x8e, (byte) 0x86, (byte) 0x3f, (byte) 0x0, (byte) 0x0, (byte) 0x80, (byte) 0x3f, (byte) 0xa, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x1c, (byte) 0x4, (byte) 0x2, (byte) 0xce, (byte) 0x1d, (byte) 0x2, (byte) 0xa0, (byte) 0xd4, (byte) 0x8a, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x9c, (byte) 0x2d, (byte) 0x47, (byte) 0x3f, (byte) 0xd0, (byte) 0x86, (byte) 0x3f, (byte) 0x9e, (byte) 0x33, (byte) 0x93, (byte) 0x41, (byte) 0xe9, (byte) 0x8e, (byte) 0x86, (byte) 0x3f, (byte) 0x0, (byte) 0x0, (byte) 0x80, (byte) 0x3f, (byte) 0xa, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x1d, (byte) 0x4, (byte) 0x2, (byte) 0xad, (byte) 0x3d, (byte) 0x3, (byte) 0x3c, (byte) 0xcf, (byte) 0x8a, (byte) 0x0, (byte) 0xdc, (byte) 0xd4, (byte) 0x8a, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0xf, (byte) 0x80, (byte) 0x51, (byte) 0x1, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x0, (byte) 0x27, (byte) 0xd7, (byte) 0x85, (byte) 0x9b};

    @Override
    public void channelActive(ChannelHandlerContext ctx) throws Exception {
        ByteBuf firstMessage = Unpooled.buffer();

        firstMessage.writeBytes(MESSAGE);
        ctx.write(firstMessage); //  alternative:  ctx.writeAndFlush(msg);
        ctx.flush();
    }

    @Override
    public void channelRead(ChannelHandlerContext ctx, Object msg) {
        ByteBuf in = (ByteBuf) msg;
        try {
            System.out.println("response:");
            while (in.isReadable()) {
                System.out.println(in.readByte());
                System.out.flush();
            }
        } finally {
            ReferenceCountUtil.release(msg);
        }
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) {
        cause.printStackTrace();
        ctx.close();
    }
}
